<?php
    //
    // vnstat PHP frontend 1.0 (c)2005 Bjorge Dijkstra (bjd@jooz.net)
    //
    // This program is free software; you can redistribute it and/or modify
    // it under the terms of the GNU General Public License as published by
    // the Free Software Foundation; either version 2 of the License, or
    // (at your option) any later version.
    //
    // This program is distributed in the hope that it will be useful,
    // but WITHOUT ANY WARRANTY; without even the implied warranty of
    // MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    // GNU General Public License for more details.
    //
    // You should have received a copy of the GNU General Public License
    // along with this program; if not, write to the Free Software
    // Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    //
    //
    // see file COPYING or at http://www.gnu.org/licenses/gpl.html 
    // for more information.
    //


    //
    // configuration parameters
    //
    // edit these to reflect your particular situation
    //

    // list of network interfaces
    $iface_list = array("eth0", "eth1", "sixxs");
    // path to the vnstat binary
    $vnstat_bin = "/usr/bin/vnstat";


    
    //
    // Valid values for other parameters you can pass to the script.
    // Input parameters will always be limited to one of the values listed here.
    // If a parameter is not provided or invalid it will revert to the default,
    // the first parameter in the list.
    //
    $page_list  = array("summary","hour","day","month");
    $theme_list = array("default");
    $graph_list = array("large","small","none");



    //
    // functions
    //
    function validate_input()
    {
	global $page,  $page_list;
	global $iface, $iface_list;
	global $graph, $graph_list;
	global $theme, $theme_list;

	//
	// get interface data
	//
	$page = $_GET["page"];
	$iface = $_GET["if"];
	$theme = $_GET["theme"];
	$graph = $_GET["graph"];

	$i = 0;	
	while (($i < count($page_list)) && ($page != $page_list[$i]))
	{
	    $i++;
	}
	if ($i == count($page_list))
	{
	    $page = $page_list[0];
	}

	$i = 0;	
	while (($i < count($iface_list)) && ($iface != $iface_list[$i]))
	{
	    $i++;
	}
	if ($i == count($iface_list))
	{
	    $iface = $iface_list[0];
	}
	
	$i = 0;	
	while (($i < count($graph_list)) && ($graph != $graph_list[$i]))
	{
	    $i++;
	}
	if ($i == count($graph_list))
	{
	    $graph = $graph_list[0];
	}
	
	$i = 0;	
	while (($i < count($theme_list)) && ($theme != $theme_list[$i]))
	{
	    $i++;
	}
	if ($i == count($theme_list))
	{
	    $theme = $theme_list[0];
	}
    }
    
    function write_tab_header()
    {
	global $iface, $page, $graph, $theme;
	$p = "&amp;if=$iface&amp;graph=$graph&amp;theme=$theme";
	print "<table border=\"0\"><tr>\n";
	printf("<td class=\"tab_%s\"><a class=\"tab\" href=\"?page=summary$p\">Summary</a></td>\n", $page == "summary" ? "front" : "back");
	printf("<td class=\"tab_%s\"><a class=\"tab\" href=\"?page=hour$p\">24 Hours</a></td>\n", $page == "hour" ? "front" : "back");
	printf("<td class=\"tab_%s\"><a class=\"tab\" href=\"?page=day$p\">30 Days</a></td>\n", $page == "day" ? "front" : "back");
	printf("<td class=\"tab_%s\"><a class=\"tab\" href=\"?page=month$p\">12 Months</a></td>\n", $page == "month" ? "front" : "back" );
	print "</tr></table>\n";
    }
    
    function write_interface_selector()
    {
	global $iface_list,$graph_list,$theme_list;
	global $page,$iface,$graph,$theme;
	
	print "<tr><td class=\"body\">\n";
	print "<form action=\"vnstat.php\"><div>";
	print "interface: <select name=\"if\">\n";
	foreach ($iface_list as $if)
	{
	    print "<option ".($if==$iface?"selected=\"selected\"":"").">$if</option>\n";	
	}
	print "</select>\n";
	print "graphs: <select name=\"graph\">\n";
	foreach ($graph_list as $gr)
	{
	    print "<option ".($gr==$graph?"selected=\"selected\"":"").">$gr</option>\n";	
	}
	print "</select>\n";

	print "theme: <select name=\"theme\">\n";
	foreach ($theme_list as $th)
	{
	    print "<option ".($th==$theme?"selected=\"selected\"":"").">$th</option>\n";	
	}
	print "</select>\n";
	
	print "<button name=\"submit\">update</button>\n";
	print "<input type=\"hidden\" name=\"page\" value=\"$page\"/>\n";
	print "</div></form>\n";
	print "</td></tr>\n";
    }
    
    function write_last_days()
    {    
    	global $day, $graph;
	
	write_page_header($graph != "none");	
	rsort($day);
	write_data_table("Last 30 days", $day,1);	
	write_page_footer();
    }


    function write_last_hours()
    {
	global $hour,$graph;
	
	write_page_header($graph != "none");
	rsort($hour);
	write_data_table("Last 24 hours", $hour,0);	
	write_page_footer();
    }
    
    
    function write_last_months()
    {
	global $month,$graph;
	
	write_page_header($graph != "none");
	rsort($month);
	write_data_table("Last 12 months", $month,1);	
	write_page_footer();
    }
    
    
    function write_summary()
    {
	global $top;
	
	write_page_header(0);	
	write_data_table("Top 10 days", $top,1);	
	write_page_footer();
    }
    
    
    function write_page_header($do_image)
    {
    	global $summary,$iface,$page,$graph;
	
	$trx = sprintf("%0.2f", (($summary["totalrx"] * 1024) + $summary["totalrxk"]) / 1024.0);
	$ttx = sprintf("%0.2f", (($summary["totaltx"] * 1024) + $summary["totaltxk"]) / 1024.0);
	print "<table>\n";
	print "<tr><td class=\"body\">\n";
	print "interface ".$summary["interface"].", total received: $trx MiB, total transmitted: $ttx MiB<br/><br/>\n";
	if ($do_image)
	{
	    print "<img src=\"$page.png\" alt=\"graph\"/>\n";
	}
    }
    
    function write_page_footer()
    {
    	print "</td></tr>\n";
	write_interface_selector();
	print "</table>\n";
    }
    
    function write_data_table($caption, $tab, $supress)
    {
	print "<table width=\"100%\">\n";
	print "<caption>$caption</caption>\n";
	print "<tr>";
	print "<th class=\"label\">&nbsp;</th>";
	print "<th class=\"label\">Receive (MiB)</th>";
	print "<th class=\"label\">Transmit (MiB)</th>";
	print "<th class=\"label\">Total (MiB)</th>";	
	print "</tr>\n";	
	for ($i=0; $i<count($tab); $i++)
	{
	    if ($tab[$i]["act"] == 1 || ($supress == 0))
	    {
		$t = $tab[$i]["label"];
	        $rx = sprintf("%0.2f", $tab[$i]["rx"]/1024.0);
	        $tx = sprintf("%0.2f", $tab[$i]["tx"]/1024.0);
		$total = sprintf("%0.2f", ($tab[$i]["rx"] + $tab[$i]["tx"])/1024.0);
    	        $id = ($i & 1) ? "odd" : "even";
	        print "<tr>";
		print "<td class=\"label_$id\">$t</td>";
		print "<td class=\"numeric_$id\">$rx</td>";
		print "<td class=\"numeric_$id\">$tx</td>";
		print "<td class=\"numeric_$id\">$total</td>";		
		print "</tr>\n";
    	    }	    
        }
	print "</table>\n";
    }

    function get_vnstat_data()
    {
	global $iface, $vnstat_bin;
	global $hour,$day,$month,$top,$summary;

	$vnstat_data = explode("\n", `$vnstat_bin --dumpdb -i $iface`);

	//
	// extract data
	//
	foreach($vnstat_data as $line) 
	{
		$d = split(";", $line);
		if ($d[0] == 'd')
		{
			$day[$d[1]]["time"]  = $d[2];
			$day[$d[1]]["rx"]    = $d[3] * 1024 + $d[5];
			$day[$d[1]]["tx"]    = $d[4] * 1024 + $d[6];
			$day[$d[1]]["act"]   = $d[7];
			$day[$d[1]]["label"] = date("d M Y", $d[2]);
			$day[$d[1]]["img_label"] = date("d", $d[2]);
		}
		else if ($d[0] == 'm')
		{
			$month[$d[1]]["time"] = $d[2];
			$month[$d[1]]["rx"]   = $d[3] * 1024 + $d[5];
			$month[$d[1]]["tx"]   = $d[4] * 1024 + $d[6];
			$month[$d[1]]["act"]  = $d[7];
			$month[$d[1]]["label"] = date("M Y", $d[2]);
			$month[$d[1]]["img_label"] = date("M", $d[2]);
		}
		else if ($d[0] == 'h')
		{
			$hour[$d[1]]["time"] = $d[2];
			$hour[$d[1]]["rx"]   = $d[3];
			$hour[$d[1]]["tx"]   = $d[4];
			$hour[$d[1]]["act"]  = $d[5];
			$hour[$d[1]]["label"] = date("H", $d[2]).":00 - ".date("H", $d[2]+3600).":00";
			$hour[$d[1]]["img_label"] = date("H", $d[2]);
		}
		else if ($d[0] == 't')
		{	
			$top[$d[1]]["time"] = $d[2];
			$top[$d[1]]["rx"]   = $d[3] * 1024 + $d[5];
			$top[$d[1]]["tx"]   = $d[4] * 1024 + $d[6];
			$top[$d[1]]["act"]  = $d[7];
			$top[$d[1]]["label"] = date("d M Y", $d[2]);
			$top[$d[1]]["img_label"] = date("d M", $d[2]);
		}
		else
		{
			$summary[$d[0]] = $d[1];
		}
	}
    }

    function init_image()
    {
	global $im, $xm, $ym, $iw, $ih,$graph, $cl;

	if ($graph == "none")
		return;

	//
	// image object
	//    
	$xm = 25;
	$ym = 25;
	if ($graph == "small")
	{
		$iw = 300 + 2*$xm;
		$ih = 100 + 2*$ym;    
	}
	else
	{
		$iw = 600 + 2*$xm;
		$ih = 200 + 2*$ym;
	}
	
	$im = imagecreate($iw,$ih);
	
	//
	// colors
	//
	$cl["white"] = imagecolorallocate($im, 255, 255, 255);
	$cl["black"] = imagecolorallocate($im, 0, 0, 0);
	$cl["grey"]  = imagecolorallocate($im, 128, 128, 128);
	$cl["rx"] = imagecolorallocate($im, 192, 192, 120);
	$cl["tx"] = imagecolorallocate($im, 192, 160, 100);
	
    }

    function draw_border()
    {
	global $im,$cl,$iw,$ih;
	
	imageline($im,     0,    0,$iw-1,    0, $cl["black"]);
	imageline($im,     0,$ih-1,$iw-1,$ih-1, $cl["black"]);
	imageline($im,     0,    0,    0,$ih-1, $cl["black"]);	
	imageline($im, $iw-1,    0,$iw-1,$ih-1, $cl["black"]);
    }
    
    function draw_grid($x_ticks, $y_ticks)
    {
	global $im, $cl, $iw, $ih, $xm, $ym;
	
	$x_step = ($iw - ($xm * 2)) / $x_ticks;
	$y_step = ($ih - ($ym * 2)) / $y_ticks;
	
	$ls = array($cl["grey"],$cl["white"]);
	imagesetstyle($im, $ls);
	for ($i=$xm;$i<=($iw-$xm); $i += $x_step)
	{
	    imageline($im, $i, $ym, $i, $ih - $ym, IMG_COLOR_STYLED);
	}
	for ($i=$ym;$i<=($ih-$ym); $i += $y_step)
	{
	    imageline($im, $xm, $i, $iw - $xm, $i, IMG_COLOR_STYLED);	
	}
	imageline($im, $xm, $ym, $xm, $ih - $ym, $cl["black"]);
	imageline($im, $xm, $ih - $ym, $iw - $xm, $ih - $ym, $cl["black"]);
    }
    
    
    function draw_data($data)
    {
	global $im,$cl,$iw,$ih,$xm,$ym;
	
	sort($data);
	
	$x_ticks = count($data);
	$y_ticks = 10;
	$y_scale = 1;
	$prescale = 1;
	$unit = 'K';
	$offset = 0;
	$gr_h = $ih - (2 * $ym);
	$x_step = ($iw - ($xm * 2)) / $x_ticks;
	$y_step = ($ih - ($ym * 2)) / $y_ticks;
	$bar_w = ($x_step / 2) - 1;
	
	//
	// determine scale
	//
	$low = 999999999;
	$high = 0;
	for ($i=0; $i<$x_ticks; $i++)
	{
	    if ($data[$i]["rx"] < $low)
		$low = $data[$i]["rx"];
	    if ($data[$i]["tx"] < $low)
		$low = $data[$i]["tx"];
	    if ($data[$i]["rx"] > $high)
		$high = $data[$i]["rx"];
	    if ($data[$i]["tx"] > $high)
		$high = $data[$i]["tx"];
	}
			

	while ($high > ($prescale * $y_scale * $y_ticks))
	{
	    $y_scale = $y_scale * 2;
	    if ($y_scale >= 1024)
	    {
		$prescale = $prescale * 1024;
		$y_scale = $y_scale / 1024;
		if ($unit == "K") 
		    $unit = "M";
		else if ($unit == "M")
		    $unit = "G";
		else if ($unit == "G")
		    $unit = "T";
	    }
	}	
	$sf = ($y_scale * $y_ticks * $prescale) / $gr_h;
	
	//
	// draw bars
	//	
	for ($i=0; $i<$x_ticks; $i++)
	{
	    $x = $xm + ($i * $x_step);
	    $y = $ym + ($ih - (2 * $ym) - (($data[$i]["tx"] - $offset) / $sf));
	    imagefilledrectangle($im, $x, $y, $x + $bar_w, $ih - $ym, $cl["tx"]);
	    
	    $y = $ym + ($ih - (2 * $ym) - (($data[$i]["rx"] - $offset) / $sf));
	    imagefilledrectangle($im, $x+$bar_w+2, $y, $x+$x_step, $ih - $ym, $cl["rx"]);
	}
	
	draw_border();
	draw_grid($x_ticks, $y_ticks);

	//
	// axis labels
	//
	for ($i=0; $i<=$y_ticks; $i+=2)
	{
    	    imagestring($im, 1, 2, ($ih - $ym) - ($i * $y_step) - 3, ($i * $y_scale).$unit, $cl["black"]);	
	}
	
	for ($i=0; $i<=$x_ticks; $i++)
	{
	    imagestring($im, 1, $xm + ($i * $x_step) + 5, $ih - $ym + 5, $data[$i]["img_label"], $cl["black"]);	
	}
    }

    function update_image()
    {
	global $page,$hour,$day,$month,$im;

	if ($page == "summary")
		return;

	init_image();

	if ($page == "hour")
	{
		draw_data($hour);
	}
	else if ($page == "day")
	{
		draw_data($day);
	}
	else if ($page == "month")
	{
		draw_data($month);
	}
	imagepng($im, "$page.png");
    }


    validate_input();

    get_vnstat_data();

    if ($graph != "none")
	    update_image();

    //
    // html start
    //
    header("Content-type: text/html; charset=utf-8");
    print "<?xml version=\"1.0\"?>\n";
    print "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">\n";
    print "<html>\n";
    print "<head>\n";
    print "<title>vnstat - PHP frontend</title>\n";
    print "<link rel=\"stylesheet\" type=\"text/css\" href=\"vnstat_$theme.css\"/>\n";
    print "</head>\n";
    print "<body>\n";
    
    print "<table width=\"700\"><tr><td>\n";
    
    print "<div class=\"title\">vnstat traffic data for $iface</div>\n";
    
    print "</td></tr>\n";
    print "<tr><td align=\"center\">\n";

    write_tab_header($page);
    
    if ($page == "summary")
    {
	write_summary();
    }
    else if ($page == "hour")
    {
	write_last_hours();
    }
    else if ($page == "day")
    {
	write_last_days();
    }
    else if ($page == "month")
    {
	write_last_months();
    }

    //
    // footer
    //
    print "<div><br/></div>\n";
    print "<div class=\"footer\"><small>vnstat PHP frontend 1.0 - &copy;2005 Bjorge Dijkstra (bjd _at_ jooz.net)</small></div>\n";

    print "</td></tr></table>\n";
    print "</body>\n";
    print "</html>\n";
?>

